using System.Linq;
using System.Web.Mvc;
using log4net;

namespace LeafWeb.WebCms.Controllers
{
	public class ActionLogAttribute : ActionFilterAttribute
	{
		public override void OnActionExecuting(ActionExecutingContext filterContext)
		{
			if (filterContext != null)
			{
				var controller = filterContext.RouteData.Values["controller"].ToString();
				var action = filterContext.RouteData.Values["action"].ToString();
				var username = filterContext.HttpContext.User.Identity.Name;
				var loggerName = $"{controller}Controller.{action}";
				var @params = string.Join(", ", filterContext.ActionParameters.Select(i => $"{i.Key}: {{{i.Value}}}"));

				var hostAddress = filterContext.HttpContext.Request.UserHostAddress;

				LogManager.GetLogger(loggerName)
					.InfoFormat("UserHostAddress: {0}, username: {1}, params: {{{2}}}", hostAddress, username, @params);
			}
			base.OnActionExecuting(filterContext);
		}
	}
}